diff --git a/examples/quantum/boron.py b/examples/quantum/boron.py
index 81f820d..073ea31 100644
--- a/examples/quantum/boron.py
+++ b/examples/quantum/boron.py
@@ -1,6 +1,6 @@
 from sfepy.base.la import norm_l2_along_axis
 
-from common import common
+from quantum_common import common
 
 
 def fun_v(ts, coor, mode=None, region=None, ig=None):
diff --git a/examples/quantum/common.py b/examples/quantum/common.py
deleted file mode 100644
index 8f88cb8..0000000
--- a/examples/quantum/common.py
+++ /dev/null
@@ -1,117 +0,0 @@
-import os
-from sfepy.fem import MeshIO
-
-def common(fun_v, mesh='../../tmp/mesh.vtk', n_eigs=5, tau=0.0):
-    filename_mesh = mesh
-
-    conf_dir = os.path.dirname(__file__)
-    dim = MeshIO.any_from_filename(filename_mesh,
-                                   prefix_dir=conf_dir).read_dimension()
-
-    options = {
-        'save_eig_vectors' : None,
-        'n_eigs' : n_eigs,
-        'eigen_solver' : 'eigen1',
-    }
-
-    # Whole domain $Y$.
-    region_1000 = {
-        'name' : 'Omega',
-        'select' : 'all',
-    }
-
-    # Domain $Y_2$.
-    region_2 = {
-        'name' : 'Surface',
-        'select' : 'nodes of surface',
-    }
-
-    functions = {
-        'fun_v' : (fun_v,),
-    }
-    
-    material_1 = {
-        'name' : 'm',
-
-        'values' : {
-            'val' : 0.5,
-        },
-    }
-
-    material_2 = {
-        'name' : 'mat_v',
-
-        'function' : 'fun_v',
-    }
-
-    if dim == 3:
-        base_approx = "3_4_P1"
-    else:
-        base_approx = "2_3_P1"
-
-    field_0 = {
-        'name' : 'field_Psi',
-        'dim' : (1,1),
-        'flags' : (),
-        'domain' : 'Omega',
-        'bases' : {'Omega' : base_approx}
-    }
-
-    if dim == 3:
-        quadr = "gauss_o2_d3"
-    else:
-        quadr = "gauss_o2_d2"
-
-    integral_1 = {
-        'name' : 'i1',
-        'kind' : 'v',
-        'quadrature' : quadr,
-    }
-
-    variable_1 = {
-        'name' : 'Psi',
-        'kind' : 'unknown field',
-        'field' : 'field_Psi',
-        'order' : 0,
-    }
-    variable_2 = {
-        'name' : 'v',
-        'kind' : 'test field',
-        'field' : 'field_Psi',
-        'dual' : 'Psi',
-    }
-    variable_3 = {
-        'name' : 'V',
-        'kind' : 'parameter field',
-        'field' : 'field_Psi',
-        'like' : 'Psi',
-    }
-
-    ebc_1 = {
-        'name' : 'ZeroSurface',
-        'region' : 'Surface',
-        'dofs' : {'Psi.0' : 0.0},
-    }
-
-    equations = {
-        'lhs' : """  dw_laplace.i1.Omega( m.val, v, Psi )
-                   + dw_mass_scalar_w.i1.Omega( mat_v.V, v, Psi )""",
-        'rhs' : """dw_mass_scalar.i1.Omega( v, Psi )""",
-    }
-
-    solver_2 = {
-        'name' : 'eigen1',
-        'kind' : 'eig.pysparse',
-
-        'tau' : tau,
-        'eps_a' : 1e-10,
-        'i_max' : 150,
-        'method' : 'qmrs',
-        'verbosity' : 0,
-        'strategy' : 1,
-    }
-
-    fe = {
-        'chunk_size' : 100000
-    }
-    return locals()
diff --git a/examples/quantum/hydrogen.py b/examples/quantum/hydrogen.py
index a70b5b5..3672e19 100644
--- a/examples/quantum/hydrogen.py
+++ b/examples/quantum/hydrogen.py
@@ -1,6 +1,6 @@
 from sfepy.base.la import norm_l2_along_axis
 
-from common import common
+from quantum_common import common
 
 def fun_v(ts, coor, mode=None, region=None, ig=None):
     from numpy import sqrt
diff --git a/examples/quantum/oscillator.py b/examples/quantum/oscillator.py
index 2e1f6bc..2f36d44 100644
--- a/examples/quantum/oscillator.py
+++ b/examples/quantum/oscillator.py
@@ -1,6 +1,6 @@
 from sfepy.base.la import norm_l2_along_axis
 
-from common import common
+from quantum_common import common
 
 def fun_v(ts, coor, mode=None, region=None, ig=None):
     if not mode == 'qp': return
diff --git a/examples/quantum/well.py b/examples/quantum/well.py
index afc19ed..9b39a6c 100644
--- a/examples/quantum/well.py
+++ b/examples/quantum/well.py
@@ -1,4 +1,4 @@
-from common import common
+from quantum_common import common
 
 def fun_v(ts, coor, mode=None, region=None, ig=None):
     from numpy import zeros_like